Library IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY pwm IS
	GENERIC(DUTY: INTEGER := 5); -- Ciclo de trabajo
	PORT(CLK: IN STD_LOGIC;
	     PWM: OUT STD_LOGIC);
END ENTITY;

ARCHITECTURE BEAS OF pwm IS
SIGNAL Q: STD_LOGIC;
SIGNAL CUENTA: INTEGER RANGE 0 TO 15;
BEGIN

	
	PROCESS(CLK) -- Periodo PWM T = CUENTA/f_CLK
	BEGIN
		IF RISING_EDGE (CLK) THEN
			IF CUENTA = 9 THEN 
				CUENTA <= 0;
			ELSE 
				CUENTA <= CUENTA + 1;
			END IF;
		END IF;
	END PROCESS;
	
	PROCESS(CUENTA) -- Comparador 
	BEGIN 
		IF CUENTA < DUTY THEN
			Q <= '1';
		ELSE 
			Q <= '0';
		END IF;
	END PROCESS;
		
	PROCESS(CLK) -- Registro
	BEGIN 
		IF RISING_EDGE(CLK) THEN
			Q <= PWM;
		END IF;
	END PROCESS;
	
END BEAS;